/* 
Legyen két sorozat, amelyeknek elemei különböző természetes számok: az a sorozat elemeinek száma n (0 < n ≤ 10 000), 
a b sorozat elemeinek száma m (0 < m ≤ 10 000) és növekvően rendezett. 
Határozzuk meg azt a c sorozatot, amelynek k (0 < k ≤ 10 000) eleme lesz, és amely a két sorozat minden közös elemét 
egyszer tartalmazza. 
Példa: ha n = 4, a = (5, -7,-2, 3), m = 5 és b = (-2, 3, 5, 7, 8), a c sorozatnak k = 3 eleme van: c = (5, -2, 3).
*/

#include <iostream>

using namespace std; 

const int maxDim = 10001;

void kiIr(int n, int x[]){

	cout << "A sorozat elemeinek szama: " << n << endl;	
	for(int i = 1; i <= n; i++)
    	cout << x[i] << " ";
  	cout << endl << endl;
}

void kozosElemek(int n, int a[], int m, int b[], int & k, int c[]){

bool megvan;
int bal, jobb, kozep;

	k = 0;								// egyelőre a c sorozatnak nincs egyetlen eleme sem
	for(int i = 1; i <= n; i++){		// bejárjuk az a sorozatot és keressük az elemeit rendre a b sorozatban
	    megvan = false; 
		bal = 1;						// mivel a b sorozat rendezett, lehetséges a bináris keresés
		jobb = m; 
		while(!megvan && bal <= jobb){
            kozep = (bal + jobb) / 2;
            if(a[i] == b[kozep]){		// megtaláltuk, tehát a[i] közös elem
            	k++;
				c[k] = a[i];			// elhelyezzük a c sorozatban
				megvan = true; 			// a keresés le fog állni
			}
            else 
				if(a[i] < b[kozep]) 
					jobb = kozep - 1;	// tovább keresünk a b sorozat bal felében
            	else 
					bal = kozep + 1;	// tovább keresünk a b sorozat jobb felében
        }
    }
}

int main(){
int n = 5;
int a[] = {0, 5, -7,-2, 3};
int m = 6;
int b[] = {0, -2, 3, 5, 7, 8};

int k;
int c[maxDim];
	kiIr(n, a);
	kiIr(m, b);
	kozosElemek(n, a, m, b, k, c);
  	kiIr(k, c);
}