#include <iostream>
#include <fstream>

using namespace std;

int const maxDim = 1500;

ifstream fin("LADAK.IN");

struct csomag{ 	  // mutató, amely egy veremmel ábrázolt csomagra mutat 
  int meret; 	    // a láda mérete 
  csomag *kov;	  // a csomagban az aktuális láda alatti láda címe 
};

void beOlvas(int & n, int meretek[]){

  fin >> n;
  for(int i = 1; i <= n; i++)
    fin >> meretek[i];   
}

void ki(int n, int meretek[]){
// beolvasott adatok kiírása

  cout << "Osszesen " << n << " lada, amelyeknek meretei: ";
  for(int i = 1; i <= n; i++)
    cout << meretek[i] << " ";
  cout << endl;
}

void init(int n, csomag *csomagok[]){
// létrehozzuk az üres csomagokat

  for(int i = 1; i <= n; i++)
    csomagok[i] = NULL;   // minden csomag üres 
}

void helyez(csomag *csomagok[], int csomagokszama, int uj){
// elhelyezzük az uj méretu ládát a csomagokszama sorszámú csomagba 
// új elem beszúrása a megfelelő verembe

  csomag *p;
  p = new csomag;
  p->meret = uj;
  p->kov = csomagok[csomagokszama];
  csomagok[csomagokszama] = p;
}

void keres(int bal, int jobb, int uj, int & csomagokszama, csomag *csomagok[]){
// keressük a bal..jobb sorszámú csomagok közt azt, amelybe elhelyezheto az uj méretu láda 
int kozep;

  if(bal > jobb){	                        // sikertelen keresés
    jobb++;                               // új csomagot kezdünk
    csomagokszama = jobb;
    helyez(csomagok, csomagokszama, uj);	 
  } 
  else{
    if(csomagok[bal]->meret > uj) 	      // sikeres keresés: az aktuális láda belefér a csomagok[bal] ládába 
      helyez(csomagok, bal, uj); 	        // az uj méretu ládát a bal sorszámú csomagba tesszük 
    else{
      kozep = (bal + jobb) / 2;	          // tovább keresünk 
      if(uj < csomagok[kozep]->meret) 
        keres(bal, kozep, uj, csomagokszama, csomagok);
      else
        keres(kozep + 1, jobb, uj, csomagokszama, csomagok);
    }
  }
}

void csomagol(int n, int meretek[], int & csomagokszama, csomag *csomagok[]){
  
  for(int i = 1; i <= n; i++)
    keres(1, csomagokszama, meretek[i], csomagokszama, csomagok);   // megkeressük az aktuális láda helyét 
}
/*
void kiIr(int csomagokszama, csomag *csomagok[]){
// ládacsomagok kiírása
csomag *fej;

  cout << "Osszesen " << csomagokszama << " csomag" << endl;
  for(int i = 1; i <= csomagokszama; i++){
    fej = csomagok[i];
    while(fej != NULL){
      cout << fej->meret << " ";
      fej = fej->kov;
    }
    cout << endl;
  }
}
*/

void kiIrVerem(csomag *fej){
// egy ládacsomag kiírása (rekurzívan, ahhoz, hogy csökkenő részsorozatot írjunk ki)

  if(fej->kov)
      kiIrVerem(fej->kov);
  cout << fej->meret << " ";
}

void kiIr(int csomagokszama, csomag *csomagok[]){
// ládacsomagok kiírása

  cout << "Osszesen " << csomagokszama << " csomag" << endl;
  for(int i = 1; i <= csomagokszama; i++){
    if(csomagok[i])
      kiIrVerem(csomagok[i]);
    cout << endl;
  }
}

int main(){
int n;
int meretek[maxDim];

int csomagokszama = 0;    // csomagok/vermek száma 
csomag *csomagok[maxDim]; // a ladacsomagok

  beOlvas(n, meretek);
  ki(n, meretek);
 
  init(n, csomagok);      // ladacsomagok/vermek inicializálása
  csomagol(n, meretek, csomagokszama, csomagok);

  kiIr(csomagokszama, csomagok);
}
